package com.ssm.controller;


import javax.persistence.Column;
import javax.persistence.Id;

import com.github.pagehelper.PageInfo;
import com.ssm.manage.entity.StaffTemporaryUpdate;
import com.ssm.manage.dto.StaffTemporaryUpdateDto;
import com.ssm.manage.response.GenericResponse;
import com.ssm.manage.response.PageResponse;
import com.ssm.manage.response.ResponseCode;
import com.ssm.manage.response.StaffTemporaryUpdateVo;
import com.ssm.manage.service.StaffTemporaryUpdateService;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;

import java.io.Serializable;

import lombok.extern.slf4j.Slf4j;
import com.ssm.core.utils.SnowflakeUtil;

import java.util.Random;

/**
 * (StaffTemporaryUpdate)表控制层
 *
 * @author makejava
 * @since 2024-03-04 09:33:21
 */
@RestController
@RequestMapping("staffTemporaryUpdate")
@Slf4j
@Api(tags = "")
public class StaffTemporaryUpdateController {
    /**
     * 服务对象
     */
    @Autowired
    private StaffTemporaryUpdateService staffTemporaryUpdateService;

/**
 * 通过主键查询单条数据
 *
 * @param id 主键
 * @return
 @GetMapping("{id}")
 @ApiOperation("通过主键查询单条数据")
 //@RequiresPermissions("system:staffTemporaryUpdate:query")
 public ResultVo get(@PathVariable Serializable id) {
 return this.staffTemporaryUpdateService.queryById(id);
 }
 */


    /**
     * 分页查询
     *
     * @param dto
     * @return
     */
    @GetMapping
    @ApiOperation("分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", defaultValue = "1", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页数量", defaultValue = "10", required = true)
    })
//@RequiresPermissions("system:staffTemporaryUpdate:query")
    public PageResponse<StaffTemporaryUpdateVo> listPage(StaffTemporaryUpdateDto dto) {
        PageResponse<StaffTemporaryUpdateVo> pageResponse = new PageResponse<>();
        PageInfo<StaffTemporaryUpdateVo> pageInfo = new PageInfo<>();
        try {
            pageInfo = this.staffTemporaryUpdateService.selectPage(dto);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.selectPage", e);
            pageResponse.setCodeAndMsg(ResponseCode.FAILED);
            return pageResponse;
        }
        pageResponse.setPageInfo(pageInfo);
        pageResponse.setCodeAndMsg(ResponseCode.OK);
        return pageResponse;
    }

    /**
     * 新增
     *
     * @param staffTemporaryUpdate
     * @return
     */
    @PostMapping
    @ApiOperation("新增")
//@RequiresPermissions("system:staffTemporaryUpdate:add")
    public GenericResponse add(@RequestBody StaffTemporaryUpdate staffTemporaryUpdate) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            staffTemporaryUpdate.setId(new SnowflakeUtil(new Random().nextInt(1023)).nextId());
            i = this.staffTemporaryUpdateService.save(staffTemporaryUpdate);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 编辑
     *
     * @param staffTemporaryUpdate
     * @return
     */
    @PutMapping
    @ApiOperation("编辑")
//@RequiresPermissions("system:staffTemporaryUpdate:edit")
    public GenericResponse edit(@RequestBody StaffTemporaryUpdate staffTemporaryUpdate) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            i = this.staffTemporaryUpdateService.updateByPrimaryKey(staffTemporaryUpdate);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 根据主键删除
     *
     * @param id 主键
     * @return
     */
    @DeleteMapping("{id}")
    @ApiOperation("根据主键删除")
//@RequiresPermissions("system:staffTemporaryUpdate:delete")
    public GenericResponse delete(@PathVariable Long id) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            StaffTemporaryUpdate staffTemporaryUpdate = new StaffTemporaryUpdate();
            staffTemporaryUpdate.setId(id);
            i = this.staffTemporaryUpdateService.delete(staffTemporaryUpdate);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

}
